<h1 id="bootstrap">Bootstrap</h1>
<h3 id="projected-time">Projected Time</h3>
<p>About 4 hours 45 minutes</p>
<ul>
<li>15 minutes for video walkthrough of slides</li>
<li>30 minutes for Independent Practice</li>
<li>4 hours for Independent Practice &amp; Challenge</li>
</ul>
<h3 id="prerequisites">Prerequisites</h3>
<ul>
<li><a href="/web/html.md">HTML lesson</a></li>
<li><a href="/web/css.md">CSS lesson</a></li>
<li><a href="../ui-ux-design/ui-ux-design.md">UI/UX lesson</a></li>
</ul>
<h3 id="motivation">Motivation</h3>
<p>Bootstrap is a popular and easy-to-use front-end framework first released by Twitter. Utilizing Bootstrap significantly reduces the amount of time spent styling your webpages, especially for mobile-development.</p>
<p><strong>Example of working websites that have used bootstrap</strong></p>
<p>Below are the examples of websites that have used bootstrap:</p>
<ul>
<li><a href="https://involvio.com/">Involvio</a></li>
<li><a href="https://www.engineyard.com/">Engine Yard</a></li>
</ul>
<h3 id="objectives">Objectives</h3>
<p><strong>Participants will be able to:</strong></p>
<ul>
<li>Create a responsive layout using Bootstrap</li>
<li>Design a website using the 12-column Grid system</li>
<li>Inspect an HTML’s box model using Chrome’s developer tools</li>
</ul>
<h3 id="specific-things-to-learn">Specific Things to Learn</h3>
<ul>
<li>How to link to Bootstrap from a CDN within your HTML head tags</li>
<li>How Bootstrap’s 12-column grid system works - Containers - Rows &amp; columns - Specifying screen widths</li>
<li>How to quickly incorporate a Bootstrap element from the official Bootstrap docs</li>
</ul>
<h3 id="supplemental-materials">Supplemental Materials</h3>
<ul>
<li><a href="https://bootstrapdocs.com/v3.3.5/docs/components/">Things you can build using Bootstrap</a></li>
<li><a href="https://bootstrapdocs.com/v3.3.5/docs/javascript/">Interactive Bootstrap features</a></li>
<li><a href="https://startbootstrap.com/template-categories/all/">Existing Bootstrap templates you can already use!</a></li>
<li><a href="https://www.youtube.com/watch?v=no-Ntkc836w">Quick video walkthrough</a></li>
</ul>
<h3 id="lesson">Lesson</h3>
<p><a href="https://drive.google.com/file/d/1O8RqmTz1hp6YejulWuq45dyn_ycZX1aP/view?usp=sharing">Bootstrap (Video walkthrough of slides)</a></p>
<p><a href="https://docs.google.com/presentation/d/17bEC3-xOEy8lt1BoT3hpQTABOUTKB7ueZeJQRiQ2YW0/edit#slide=id.g22b045fc2c_0_8">Bootstrap (slides)</a></p>
<h3 id="things-to-remember">Things to Remember</h3>
<ul>
<li><strong>Bootstrap is currently on version 4</strong></li>
<li><strong>There is no need to download the Bootstrap files.</strong> Simply use a CDN link as shown in the slides and the Bootstrap docs.</li>
<li><strong>There is a</strong> <code>bootstrap.css</code> <strong>and a</strong> <code>bootstrap.js</code> <strong>.</strong> The <code>bootstrap.css</code> file is what most people refer to when they talk about Bootstrap. The <code>bootstrap.js</code> file is only necessary when you want to make interactive components like drop-down menus, modals, and the like. In that case, you’ll need to use <code>bootstrap.js</code> <strong>in addition to</strong> <code>bootstrap.css</code>.</li>
<li><strong>The</strong> <code>bootstrap.js</code> <strong>file needs jQuery in order to work.</strong> Make sure you’ve linked to the jQuery CDN <strong>above</strong> your link to the <code>bootstrap.js</code> CDN.</li>
</ul>
<h3 id="independent-practice">Independent Practice</h3>
<p><strong>Activity 1 - What Can Be Done with Bootstrap?</strong></p>
<p>This is an independent activity and pairs will not be assigned.</p>
<p>Spend 20 minutes exploring this link given in the “Supplemental Materials" section above: <a
        href="https://bootstrapdocs.com/v3.3.5/docs/components/">Things you can build using Bootstrap</a>. Make a list
    that includes some of the most useful components, your favorite components, or components you think would be really
    neat to add to a project.</p>
<p>Spend 10 minutes exploring this link given in the “Supplemental Materials" section above: <a
        href="https://bootstrapdocs.com/v3.3.5/docs/javascript/">Interactive Bootstrap features</a>. Add some of these
    features to the list you created in the first portion.</p>
<p><strong>Activity 2 - Your First Bootstrap Webpage!</strong></p>
<p>Techtonica staff will assign pairs.</p>
<ol type="1">
<li><p>Using your Terminal, navigate to your Desktop.</p></li>
<li><p>Create a new directory called <code>vegetables-webpage</code>.</p></li>
<li><p>Navigate to <code>vegetables-webpage</code>. Open the whole directory with <code>code .</code> .</p></li>
<li><p>Create a file called <code>vegetables.html</code>. It should automatically appear in the left sidebar in VS Code as an editable file.</p></li>
<li>
    <p>Open <a href="https://www.teaching-materials.org/bootstrap-hosting-github/exercises/grid/grid_instructions">this
            lab exercise</a> in a new tab by pressing <code>&lt;CONTROL&gt;</code> and clicking on the link. A selection
        box will appear. Click on “Open in new tab".</p>
</li>
<li>
    <p>Open the link provided in the first bullet point in a new tab as well. Using the Quick Source Viewer Chrome
        extension you installed in the “Chrome Developer Tools" lesson, view the HTML and talk through the code with
        your pair partner. Can you explain what each section accomplishes? Once you feel satisfied that you understand
        what the code is doing, move on to the next step.</p>
</li>
<li><p>Copy the HTML you accessed in the previous step into <code>vegetables.html</code>. Save the file. Close the Chrome tab that you opened in Step 6 (the one you used the Chrome Quick Source Viewer extension on).</p></li>
<li><p>In a new tab, open <code>vegetables.html</code> in Chrome using one of the techniques you learned in the “HTML" lesson. It should look the same as the example you saw a moment ago. You’ll refer back to this tab through this exercise as you add code and refresh this webpage.</p></li>
<li><p>Continue on with the tutorial you opened in Step 5 and see how far you can get. You’ll likely make small bursts of progress using trial and error. That’s OK! Be patient with yourself. Remember to stick to the 20-minute rule before asking a peer or instructor for help. Before clicking “Show Solution" at the bottom of the tutorial, please give this exercise a good-faith effort.</p></li>
</ol>
<h3 id="challenge">Challenge</h3>
<ol type="1">
<li><p>Did you specify in <code>vegetables.html</code> column widths for various screen sizes? If you didn’t, please do so now.</p></li>
<li><p>Using online resources, add a Bootstrap modal window component to your Vegetables webpage. The modal window should display some content, and also open and close. Remember: which Bootstrap CDN link do you need to add before you can add interactive features?</p></li>
</ol>
<h3 id="check-for-understanding">Check for Understanding</h3>
<p>Form small groups and discuss - What is a grid system? - What is a responsive layout? - How to customize Bootstrap? - What can you build with Bootstrap? - Why use Bootstrap?</p>
